package org.jvnet.jaxbcommons.catchup.addon;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jvnet.jaxbcommons.addon.AbstractParameterizableCodeAugmenter;
import org.xml.sax.ErrorHandler;

import com.sun.tools.xjc.BadCommandLineException;
import com.sun.tools.xjc.CodeAugmenterEx;
import com.sun.tools.xjc.Options;
import com.sun.tools.xjc.generator.GeneratorContext;
import com.sun.tools.xjc.grammar.AnnotatedGrammar;

public class AddOn extends AbstractParameterizableCodeAugmenter implements CodeAugmenterEx {

  protected Log logger = LogFactory.getLog(getClass());

  private List customizationURIs = new ArrayList();

  public List getCustomizationURIs() {
    return customizationURIs;
  }

  public void setCustomizationURI(String uri) {
    logger.debug("Catching up URI [" + uri + "].");
    this.customizationURIs.add(uri);
  }

  public String getOptionName() {
    return "Xcatchup";
  }

  public String getUsage() {
    return "-Xcatchup";
  }

  public int parseArgument(Options opt, String[] args, int start)
      throws BadCommandLineException,
      IOException {
    final int result = super.parseArgument(opt, args, start);
    opt.enabledCustomizationURIs.addAll(customizationURIs);
    return result;
  }

  public boolean run(
      AnnotatedGrammar arg0,
      GeneratorContext arg1,
      Options options,
      ErrorHandler arg3) {
    return true;
  }

  //  
  //  
  //
  //  /**
  //   * Logger.
  //   */
  //	  protected Logger logger = LoggerFactory.getLogger(getClass());
  //
  //  /**
  //   * Does nothing.
  //   *
  //   * @param opt  ignored.
  //   * @param args ignored.
  //   * @param i    ignored.
  //   * @return Alway returns <code>0</code>.
  //   * @throws com.sun.tools.xjc.BadCommandLineException
  //   *                             Never thrown.
  //   * @throws java.io.IOException Never thrown.
  //   */
  //  public int parseArgument(final Options opt, final String[] args, final int i)
  //      throws BadCommandLineException, IOException {
  //    return 0;   // no option recognized
  //  }
  //
  //  public String getOptionName() {
  //    return "XextendedHashCode";
  //  }
  //
  //  public String getUsage() {
  //    return "  -XextendedHashCode                   :  adds hashCode() method";
  //  }
  //
  //  /**
  //   * Augments the code.
  //   *
  //   * @param grammar          annotated grammar.
  //   * @param generatorContext generator context.
  //   * @param options          options.
  //   * @param errorHandler     error handler.
  //   * @return If the add-on executes successfully, return true. If it detects some errors but those are reported and
  //   *         recovered gracefully, return false.
  //   */
  //  public boolean run(final AnnotatedGrammar grammar, final GeneratorContext generatorContext,
  //                     final Options options, final ErrorHandler errorHandler) {
  //
  //    logger.debug("Starting code augmentation.");
  //
  //    // Process class items
  //    final ClassItem[] classItems = grammar.getClasses();
  //    logger.debug("Processing [" + classItems.length + "] class items.");
  //    for (int index = 0; index < classItems.length; index++) {
  //      final ClassItem classItem = classItems[index];
  //      final ClassContext classContext = generatorContext.getClassContext(classItem);
  //      logger.debug("Processing [" + classItem.name + "].");
  //      getStrategy().generate(classContext, null, classContext.implClass);
  //    }
  //    logger.debug("Finished processing class items.");
  //    logger.debug("Finished code augmentation.");
  //    return true;
  //  }
  //
  //  protected MethodStrategy strategy = new HashCodeStrategy();
  //
  //  public MethodStrategy getStrategy() {
  //    return strategy;
  //  }
  //  
  //  public void setStrategy(MethodStrategy strategy) {
  //    this.strategy = strategy;
  //  }
}
