package org.jvnet.jaxbcommons.enums.addon.util;

import java.util.Collection;

import org.jvnet.jaxbcommons.visitor.enums.EnumValuesVisitor;

import com.sun.msv.grammar.ChoiceExp;
import com.sun.msv.grammar.Expression;
import com.sun.msv.grammar.ValueExp;
import com.sun.msv.grammar.util.ExpressionPrinter;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.FieldItem;

public class EnumUtils {

  private EnumUtils() {
  }

  public static Collection getValues(final ClassContext classContext, final FieldItem fieldItem) {
    final Collection enumValues = (Collection) fieldItem.visit(new EnumValuesVisitor(classContext));
    return enumValues;
  }

  public static ValueExp[] getValues(Expression exp) {
    if (!(exp instanceof ChoiceExp)) {
      if (!(exp instanceof ValueExp)) {
        // System.out.println(ExpressionPrinter.printContentModel(exp));
        // it must be a choice or value exps.
        throw new InternalError("assertion failed");
      }
      return new ValueExp[]{ (ValueExp) exp };
    }
    else {
      Expression[] children = ((ChoiceExp) exp).getChildren();
      ValueExp[] values = new ValueExp[children.length];
      System.arraycopy(children, 0, values, 0, children.length);
      return values;
    }
  }
}
